"use strict";

var _fs = require("fs");

var _webpackMerge = require("webpack-merge");

var _common = require("@srejs/common");

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

module.exports = function (config, isServer) {
  if (!_fs.existsSync(_common.webpackConfigPath)) {
    return config;
  }

  var customConfig = config;
  delete require.cache[require.resolve(_common.webpackConfigPath)];

  var configureWebpack = require(_common.webpackConfigPath);

  if (typeof configureWebpack === 'function') {
    // apply customConfig
    customConfig = Reflect.apply(configureWebpack, config, [config, isServer ? 'ssr' : 'csr']);
  }

  if (_typeof(configureWebpack) === 'object') {
    // webpack-merge
    customConfig = (0, _webpackMerge.merge)(config, configureWebpack);
  }

  return customConfig;
};