"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Hotwebpack = exports.DevMiddlewareFileSystem = void 0;

var _webpack = require("webpack");

var fs = _interopRequireWildcard(require("fs"), true);

var _koaWebpackMiddleware = require("koa-webpack-middleware");

var _dev = require("./dev");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DevMiddlewareFileSystem = fs;
exports.DevMiddlewareFileSystem = DevMiddlewareFileSystem;

var Hotwebpack = /*#__PURE__*/function () {
  function Hotwebpack(app) {
    var page = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

    _classCallCheck(this, Hotwebpack);

    this.app = app;
    this.webpackConfig = (0, _dev.getDevConfig)(page, false, true);
    this.complier = _webpack(this.webpackConfig);
    this.webpackDevMiddleware();
    this.webpackHotMiddleware();
  }

  _createClass(Hotwebpack, [{
    key: "webpackHotMiddleware",
    value: function webpackHotMiddleware() {
      var hotPath = '/__webpack_hmr';

      var _hotMiddleware = (0, _koaWebpackMiddleware.hotMiddleware)(this.complier, {
        path: hotPath,
        log: console.warn,
        heartbeat: 2000
      }); // 中间件过滤非 /__webpack_hmr路由


      this.app.use(function (ctx, next) {
        if (ctx.url !== hotPath) {
          return next();
        } else {
          _hotMiddleware(ctx, next);
        }
      });
    }
  }, {
    key: "webpackDevMiddleware",
    value: function webpackDevMiddleware() {
      var _devMiddleware = (0, _koaWebpackMiddleware.devMiddleware)(this.complier, {
        serverSideRender: false,
        publicPath: '/',
        noInfo: true,
        quiet: true,
        index: false //不响应根路径请求 避免和页面组件路由冲突

      });

      exports.DevMiddlewareFileSystem = DevMiddlewareFileSystem = _devMiddleware.fileSystem; // 中间件过滤 非静态资源目录访问 .html,.js,.css,.png,jpeg,.svg,.jpg,.ttf

      this.app.use(function (ctx, next) {
        var filename = _devMiddleware.getFilenameFromUrl(ctx.url);

        if (filename === false) return next();

        try {
          var stat = DevMiddlewareFileSystem.statSync(filename);

          if (!stat.isFile()) {
            return next();
          }

          _devMiddleware(ctx, next);
        } catch (_e) {
          return next();
        }
      });
    }
  }]);

  return Hotwebpack;
}();

exports.Hotwebpack = Hotwebpack;