"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Webpack = void 0;

var _regenerator = require("@babel/runtime/regenerator");

var _webpack = require("webpack");

var _common = require("@srejs/common");

var _prod = require("./prod");

var _dev = require("./dev");

var _server = require("./server");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Webpack = /*#__PURE__*/function () {
  /**
   *
   * @param {*} pages 支持单独文件构建编译 默认true编译全部web页面组件
   * @param {*} dev 开发环境
   * @param {*} server 服务端编译模式
   */
  function Webpack(pages) {
    var dev = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var server = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    _classCallCheck(this, Webpack);

    this.page = pages;
    this.dev = dev;
    this.Compiler = _webpack(server ? (0, _server.getServerconfig)(this.page) : this.getWebpackConfig(this.page));
  }

  _createClass(Webpack, [{
    key: "getWebpackConfig",
    value: function getWebpackConfig(page) {
      if (this.dev) {
        return (0, _dev.getDevConfig)(page, false);
      } else {
        return (0, _prod.getProconfig)(page, false);
      }
    }
  }, {
    key: "run",
    value: function () {
      var _run = _asyncToGenerator( /*#__PURE__*/_regenerator.mark(function _callee() {
        return _regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", this.dev ? this.watching() : this.compilerRun());

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function run() {
        return _run.apply(this, arguments);
      }

      return run;
    }()
  }, {
    key: "compilerRun",
    value: function compilerRun() {
      var _this = this;

      return new Promise(function (resove, reject) {
        _this.Compiler.run(function (err, stats) {
          if (err) {
            reject(err.stack || err);
          }

          _this.log(stats);

          resove(true);
        });
      });
    }
  }, {
    key: "watching",
    value: function watching() {
      var _this2 = this;

      this.Compiler.watch({
        aggregateTimeout: 300,
        ignored: '**/node_modules',
        poll: 1000
      }, function (err, stats) {
        _this2.log(stats);
      });
    }
  }, {
    key: "log",
    value: function log(stats) {
      _common.Logger.info(stats.toString({
        publicPath: false,
        performance: false,
        env: false,
        depth: false,
        colors: true,
        assets: true,
        cachedAssets: false,
        children: false,
        chunks: false,
        modules: false,
        warnings: false,
        entrypoints: false
      }));
    }
  }], [{
    key: "build",
    value: function () {
      var _build = _asyncToGenerator( /*#__PURE__*/_regenerator.mark(function _callee2(page) {
        return _regenerator.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _common.spinner.start();

                _common.spinner.color('yellow');

                _common.spinner.text('客户端构建');

                _context2.next = 5;
                return new Webpack(page, false, false).compilerRun();

              case 5:
                _common.spinner.text('服务端构建');

                _common.spinner.color('blue');

                _context2.next = 9;
                return new Webpack(page, false, true).compilerRun();

              case 9:
                _common.spinner.stop();

              case 10:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function build(_x) {
        return _build.apply(this, arguments);
      }

      return build;
    }()
  }]);

  return Webpack;
}();

exports.Webpack = Webpack;
process.on('message', function (_ref) {
  var page = _ref.page,
      dev = _ref.dev,
      server = _ref.server;
  new Webpack(page, dev, server).run(); // 启动时只提取构建服务端所需资源
});